<?php
/**
 * Google XML Sitemap Feed
 *
 * @package Google XML Sitemap Feed
 * @copyright Copyright 2005-2007, Andrew Berezin
 * @copyright Portions Copyright 2005, Bobby Easland
 * @copyright Copyright 2003-2006 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @link http://www.google.com/webmasters/sitemaps/docs/en/about.html About Google Sitemap
 * @version $Id: googlesitemap.php, v 1.3.7 19.03.2007 19:14 Andrew Berezin andrew@ecommerce-service.com$
 */
	@define('GOOGLE_SITEMAP_VERSION', 'v 1.3.7 19.03.2007 19:14');

	require_once('includes/application_top.php');

	$time_start = explode (' ', microtime());

	@define('GOOGLE_SITEMAP_COMPRESS', 'false');
	@define('GOOGLE_SITEMAP_PROD_CHANGE_FREQ', 'weekly');
	@define('GOOGLE_SITEMAP_CAT_CHANGE_FREQ', 'weekly');
	@define('GOOGLE_SITEMAP_LASTMOD_FORMAT', 'date');
	@define('GOOGLE_SITEMAP_CAT_CHANGE_PRIOR', 0.5);
	@define('GOOGLE_SITEMAP_USE_XSL', 'true');
	@define('GOOGLE_SITEMAP_USE_ROOT_DIRECTORY', 'true');

	@define('GOOGLE_SITEMAP_EZPAGES_HEADER', 'true');
	@define('GOOGLE_SITEMAP_EZPAGES_SIDEBOX', 'true');
	@define('GOOGLE_SITEMAP_EZPAGES_FOOTER', 'true');
	@define('GOOGLE_SITEMAP_EZPAGES_CHANGE_FREQ', 'weekly');
	@define('GOOGLE_SITEMAP_EZPAGES_CHANGE_PRIOR', 0.5);

	@define('GOOGLE_SITEMAP_MAX_ENTRYS', 50000);
	@define('GOOGLE_SITEMAP_MAX_SIZE', 10000000); //10485760

	if(isset($_REQUEST["zenAdminID"])) define('START_FROM_ADMIN', true);

	if (!get_cfg_var('safe_mode') && function_exists('safe_mode')) {
		set_time_limit(0);
	}

	function timefmt($s) {
		$m = floor($s/60);
		$s = $s - $m*60;
		return $m . ":" . number_format($s, 4);
	}

echo 'Google Sitemap Generation (' . GOOGLE_SITEMAP_VERSION . ') started<br /><br />' . "\n\n";

$google = new GoogleSitemap(DB_SERVER, DB_SERVER_USERNAME, DB_DATABASE, DB_SERVER_PASSWORD);
$submit = true;

echo '<br />';
if ($google->GenerateProductSitemap()){
	echo 'Generated Google Product Sitemap Successfully' . ' - <a href="' . $google->base_url . 'sitemapproducts.xml" target="_blank">' . $google->base_url . 'sitemapproducts.xml</a><br />' . "\n";
} else {
	$submit = false;
	echo '<span style="font-weight: bold; color: red;">ERROR: Google Product Sitemap Generation FAILED!</span><br />' . "\n\n";
}

echo '<br />';
if ($google->GenerateCategorySitemap()){
	echo 'Generated Google Category Sitemap Successfully' . ' - <a href="' . $google->base_url . 'sitemapcategories.xml" target="_blank">' . $google->base_url . 'sitemapcategories.xml</a><br />' . "\n";
} else {
	$submit = false;
	echo '<span style="font-weight: bold; color: red;">ERROR: Google Category Sitemap Generation FAILED!</span><br />' . "\n\n";
}

echo '<br />';
if ($google->GenerateEzpagesSitemap()){
	echo 'Generated Google EZPages Sitemap Successfully' . ' - <a href="' . $google->base_url . 'sitemapezpages.xml" target="_blank">' . $google->base_url . 'sitemapezpages.xml</a><br />' . "\n";
} else {
	$submit = false;
	echo '<span style="font-weight: bold; color: red;">ERROR: Google Category Sitemap Generation FAILED!</span><br />' . "\n\n";
}

////////////////////////////////////
// include the list of extra configure files
/*
	define('DIR_WS_GOOGLESITEMAP_PLUGINS', DIR_WS_INCLUDES . 'plugins/googlesitemap');
	if ($za_dir = @dir(DIR_WS_GOOGLESITEMAP_PLUGINS)) {
		while ($zv_file = $za_dir->read()) {
			if (preg_match('/\.php$/', $zv_file) > 0) {
				if ($google->GeneratePluginSitemap(DIR_WS_GOOGLESITEMAP_PLUGINS . '/' . $zv_file)){
					echo 'Generated Google Sitemap Plugin [' . basename(DIR_WS_GOOGLESITEMAP_PLUGINS . '/' . $zv_file, ".php") . '] Successfully<br />' . "\n\n";
				} else {
					$submit = false;
					echo '<span style="font-weight: bold; color: red;">ERROR: Google Sitemap Sitemap Plugin [' . basename(DIR_WS_GOOGLESITEMAP_PLUGINS . '/' . $zv_file) . '] Generation FAILED!</span><br />' . "\n\n";
				}
			}
		}
	}
*/
////////////////////////////////////
echo '<br />';
if ($google->GenerateSitemapIndex()){
	echo 'Generated Google Sitemap Index Successfully' . ' - <a href="' . $google->base_url . 'sitemapindex.xml" target="_blank">' . $google->base_url . 'sitemapindex.xml</a><br /><br />' . "\n\n";
} else {
	$submit = false;
	echo '<span style="font-weight: bold; color: red;">ERROR: Google Sitemap Index Generation FAILED!</span><br /><br />' . "\n\n";
}

if ($submit){
	if (isset($_GET['ping']) && $_GET['ping'] == 'yes') {
		fopen($google->GenerateSubmitURL(), 'r');
	}
	echo 'If you have not already submitted the sitemap index to Google click this link <a href="' . $google->GenerateSubmitURL() . '">Google Ping</a><br /><br />' . "\n\n";
}

	$time_end = explode (' ', microtime());
	$total_time = $time_end[1]+$time_end[0]-$time_start[1]-$time_start[0];

	echo 'Total Execution Time ' . timefmt($total_time) . '<br />';

////////////////////////////////////////////////////////////////////////
// Google Sitemap Base Class

class GoogleSitemap{
	var $filename;
	var $savepath;
	var $base_url;

	function GoogleSitemap(){
		global $db;
		$this->filename = "sitemap";
		if(GOOGLE_SITEMAP_XML_FS_DIRECTORY == '') {
			$this->savepath = DIR_FS_CATALOG;
			$this->base_url = HTTP_SERVER . DIR_WS_CATALOG;
		} else {
			$this->savepath = rtrim(GOOGLE_SITEMAP_XML_FS_DIRECTORY, '/') . '/';
			$this->base_url = HTTP_SERVER . '/';
		}
		echo 'Save path - "' . $this->savepath . '"' . '<br />';
		echo 'Base URL - "' . $this->base_url . '"' . '<br />';
	}

// save the sitemap data to file as either XML or XML.GZ format
	function SaveFileXML($data, $type, $records){
		$filename = $this->savepath . $this->filename . $type;
		$compress = defined('GOOGLE_SITEMAP_COMPRESS') ? GOOGLE_SITEMAP_COMPRESS : 'false';
		if ($type == 'index') $compress = 'false';
		switch($compress){
			case 'true':
				$filename .= '.xml.gz';
				echo 'Processing file: ' . $filename;
				if ($gz = gzopen($filename,'wb9')){
					gzwrite($gz, $data, strlen($data));
					gzclose($gz);
					echo ' OK! Written ' . $records . ' records, ' . strlen($data) . ' bytes <br />';
					return true;
				} else {
					echo ' Failed!<br />';
					$file_check = file_exists($filename) ? 'true' : 'false';
					return false;
				}
				break;
			default:
				$filename .= '.xml';
				echo 'Processing file: ' . $filename;
				if ($fp = fopen($filename, 'w+')){
					fwrite($fp, $data, strlen($data));
					fclose($fp);
					echo ' OK! Written ' . $records . ' records, ' . strlen($data) . ' bytes <br />';
					return true;
				} else {
					echo ' Failed!<br />';
					$file_check = file_exists($filename) ? 'true' : 'false';
					return false;
				}
				break;
		}
	}

// generate sitemap file from data
	function GenerateSitemap($data, $file){
		$contentXML = "";
		$number = 0;
		$file_num = 1;
		$ret = false;
		if(!is_array($data) || sizeof($data) <= 0) {
			return $this->SaveFileXML('', $file, 0);
		}
		foreach ($data as $url){
			if ($number >= GOOGLE_SITEMAP_MAX_ENTRYS || strlen($contentXML) >= GOOGLE_SITEMAP_MAX_SIZE) {
				$ret = $this->SaveFileXML($this->GoogleXMLHeader('urlset') . $contentXML . '</urlset>', $file . substr('000' . $file_num, -3), $number);
				$file_num++;
				$contentXML = "";
				$number = 0;
			}
			$number++;
			$contentXML .= ' <url>' . "\n";
			$contentXML .= '  <loc>' . utf8_encode($url['loc']) . '</loc>' . "\n";
			if(isset($url['lastmod']) && $url['lastmod'] != '')
				$contentXML .= '  <lastmod>' . $this->LastMod($url['lastmod']) . '</lastmod>' . "\n";
			if(isset($url['changefreq']) && $url['changefreq'] != '')
				$contentXML .= '  <changefreq>' . $url['changefreq'] . '</changefreq>' . "\n";
			if(isset($url['priority']) && $url['priority'] != '')
				$contentXML .= '  <priority>' . $url['priority'] . '</priority>' . "\n";
			$contentXML .= ' </url>' . "\n";
		}
		if ($contentXML != "") {
			$ret = $this->SaveFileXML($this->GoogleXMLHeader('urlset') . $contentXML . '</urlset>', $file . ($file_num == 1 ? '' : substr('000' . $file_num, -3)), $number);
		}
		return $ret;
	}

// generate sitemap index file
	function GenerateSitemapIndex(){
		$content = $this->GoogleXMLHeader('sitemapindex');
		$records_count = 0;
		if ($za_dir = @dir(rtrim($this->savepath, '/'))) {
			while ($filename = $za_dir->read()) {
				$pattern = (GOOGLE_SITEMAP_COMPRESS == 'true' ? '(?:\.xml|\.gz)' : '\.xml');
				if (preg_match('/^' . $this->filename . '.*' . $pattern . '$/', $filename) > 0) {
					if (strpos($filename, $this->filename . 'index.') === 0) continue;
					clearstatcache();
					if (!filesize($filename)) continue;
					$content .= ' <sitemap>' . "\n";
					$content .= '  <loc>' . $this->base_url . basename($filename) . '</loc>' . "\n";
					$content .= '  <lastmod>' . $this->LastMod(filemtime($this->savepath . $filename)) . '</lastmod>' . "\n";
					$content .= ' </sitemap>' . "\n";
					$records_count++;
				}
			}
		}
		$content .= '</sitemapindex>';
		return $this->SaveFileXML($content, 'index', $records_count);
	}

// generate product sitemap data
	function GenerateProductSitemap(){
		global $db;
		$container = array();
		$products = $db->Execute("SELECT max(products_ordered) as max_products_ordered
															FROM " . TABLE_PRODUCTS . "
															WHERE products_status = '1'");
		$max_products_ordered = $products->fields[max_products_ordered];

		$products = $db->Execute("SELECT p.products_id, GREATEST(p.products_date_added, p.products_last_modified) AS last_date, p.products_ordered, l.code
															FROM " . TABLE_PRODUCTS . " p
																LEFT JOIN " . TABLE_PRODUCTS_DESCRIPTION . " pd ON (p.products_id = pd.products_id)
																LEFT JOIN " . TABLE_LANGUAGES . " l ON (pd.language_id = l.languages_id)
															WHERE p.products_status = '1'
															ORDER BY p.products_ordered desc");
		while(!$products->EOF){
			$ratio = ($max_products_ordered > 0 ? number_format($products->fields['products_ordered']/$max_products_ordered, 2) : 1);
			if (defined('GOOGLE_SITEMAP_PROD_CHANGE_PRIOR') && GOOGLE_SITEMAP_PROD_CHANGE_PRIOR != 0)
				$priority = GOOGLE_SITEMAP_PROD_CHANGE_PRIOR;
			else
				$priority = $ratio < 0.1 ? 0.1 : $ratio;
			if($products->fields['code'] != DEFAULT_LANGUAGE)
				$product_url_add = '&language=' . $products->fields['code'];
			else
				$product_url_add = '';
			$container[] = array('loc' => zen_href_link(zen_get_info_page($products->fields['products_id']), 'products_id=' . $products->fields['products_id'] . $product_url_add, 'NONSSL', false),
													 'lastmod' => strtotime($products->fields['last_date']),
													 'changefreq' => GOOGLE_SITEMAP_PROD_CHANGE_FREQ,
													 'priority' => $priority);
			$products->MoveNext();
		}
		return $this->GenerateSitemap($container, 'products');
	}

// generate category sitemap data
	function GenerateCategorySitemap(){
		global $db;
		$container = array();
		$categories = $db->Execute("select c.categories_id, GREATEST(c.date_added, c.last_modified) AS last_date, l.code
					from " . TABLE_CATEGORIES . " c
						left join " . TABLE_CATEGORIES_DESCRIPTION . " cd on (cd.categories_id = c.categories_id)
						left join " . TABLE_LANGUAGES . " l on (cd.language_id = l.languages_id)
					where c.categories_status = '1'
					order by c.sort_order asc, c.parent_id asc, c.categories_id asc");
		while(!$categories->EOF){
			$container[] = array('loc' => zen_href_link(FILENAME_DEFAULT, ($categories->fields['code'] != DEFAULT_LANGUAGE ? 'language=' . $categories->fields['code'] : "") . '&cPath=' . $this->GetFullcPath($categories->fields['categories_id']), 'NONSSL', false),
													 'lastmod' => strtotime($categories->fields['last_date']),
													 'changefreq' => GOOGLE_SITEMAP_CAT_CHANGE_FREQ,
													 'priority' => GOOGLE_SITEMAP_CAT_CHANGE_PRIOR);
			$categories->MoveNext();
		}
		return $this->GenerateSitemap($container, 'categories');
	}

// generate Ezpages sitemap data
	function GenerateEzpagesSitemap(){
		global $db;
		$where = array();
		if(GOOGLE_SITEMAP_EZPAGES_HEADER == 'true')  $where[] = '(status_header = 1 AND header_sort_order > 0)';
		if(GOOGLE_SITEMAP_EZPAGES_SIDEBOX == 'true') $where[] = '(status_sidebox = 1 AND sidebox_sort_order > 0)';
		if(GOOGLE_SITEMAP_EZPAGES_FOOTER == 'true')  $where[] = '(status_footer = 1 AND footer_sort_order > 0)';
		if(sizeof($where) == 0) return false;
		$container = array();
		$page_query = $db->Execute("SELECT * FROM " . TABLE_EZPAGES . " WHERE " . implode('OR',$where) . " ORDER BY sidebox_sort_order, pages_title");
		while (!$page_query->EOF) {
			if($page_query->fields['alt_url_external'] == '') { // skip external link
				if($page_query->fields['alt_url'] != '') { // internal link
					$link = (substr($page_query->fields['alt_url'],0,4) == 'http') ?
						$page_query->fields['alt_url'] :
						zen_href_link($page_query->fields['alt_url'], '', ($page_query->fields['page_is_ssl']=='0' ? 'NONSSL' : 'SSL'), true, true, true);
				} else { // use EZPage ID to create link
					$link = zen_href_link(FILENAME_EZPAGES, 'id=' . $page_query->fields['pages_id'] . '&chapter=' . $page_query->fields['toc_chapter'], ($page_query->fields['page_is_ssl']=='0' ? 'NONSSL' : 'SSL'));
				}
				$container[] = array('loc' => $link,
//														 'lastmod' => time(),
														 'changefreq' => GOOGLE_SITEMAP_EZPAGES_CHANGE_FREQ,
														 'priority' => GOOGLE_SITEMAP_EZPAGES_CHANGE_PRIOR);
			}
			$page_query->MoveNext();
		}
		return $this->GenerateSitemap($container, 'ezpages');
	}

//
	function GeneratePluginSitemap($plugin_file){
		$sitemap_container = array();
		$sitemap_filename = basename($plugin_file, ".php");
		include($plugin_file);
		if(sizeof($sitemap_container) > 0)
			return $this->GenerateSitemap($sitemap_container, $sitemap_filename);
		return false;
	}

// retrieve full cPath from category ID
	function GetFullcPath($cID){
		global $db;
		static $parent_cache = array();
		$cats = array();
		$cats[] = $cID;
		$parent = $db->Execute("SELECT parent_id, categories_id
														FROM " . TABLE_CATEGORIES . "
														WHERE categories_id=" . (int)$cID);
		while(!$parent->EOF && $parent->fields['parent_id'] != 0) {
			$parent_cache[(int)$parent->fields['categories_id']] = (int)$parent->fields['parent_id'];
			$cats[] = $parent->fields['parent_id'];
			if(isset($parent_cache[(int)$parent->fields['parent_id']])) {
				$parent->fields['parent_id'] = $parent_cache[(int)$parent->fields['parent_id']];
			} else {
				$parent = $db->Execute("SELECT parent_id, categories_id
																FROM " . TABLE_CATEGORIES . "
																WHERE categories_id=" . (int)$parent->fields['parent_id']);
			}
		}
		$cats = array_reverse($cats);
		$cPath = implode('_', $cats);
		return $cPath;
	}

// generate the submit URL
	function GenerateSubmitURL(){
		return utf8_encode('http://www.google.com/webmasters/sitemaps/ping?sitemap=' . urlencode($this->base_url . 'sitemapindex.xml'));
	}

// format the LastMod field
	function LastMod($date){
		if(GOOGLE_SITEMAP_LASTMOD_FORMAT == 'full') {
			$timezone = date('O',$date);
			return gmdate('Y-m-d\TH:i:s', $date) . substr($timezone, 0, 3) . ":" . substr($timezone, 3, 2);
		} else {
			return gmdate('Y-m-d', $date);
		}
	}

// Utility function to format the Google XML Header
	function GoogleXMLHeader($tag){
		return '<?xml version="1.0" encoding="UTF-8"?'.'>' . "\n" .
					(GOOGLE_SITEMAP_USE_XSL == 'true' ? '<?xml-stylesheet type="text/xsl" href="gss.xsl"?'.'>' . "\n" : "") .
					 '<' . $tag . ' xmlns="http://www.google.com/schemas/sitemap/0.84"' . "\n" .
					 'xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"' . "\n" .
					 'xsi:schemaLocation="http://www.google.com/schemas/sitemap/0.84' . "\n" .
					 'http://www.google.com/schemas/sitemap/0.84/' . ($tag == 'urlset' ? 'sitemap.xsd' : 'siteindex.xsd') . '">' . "\n";
	}

	function get_hhtp_lastmodified($get_url){
		$url = @parse_url($get_url);
		if (!$url)
			return false;
		if (isset($url["user"])) {
			$xhdr .= 'Authorization: Basic ' . base64_encode($url["user"] . ":" . $url["pass"]) . "\n";
		}
		$url["query"] = (!empty($url["query"]) ? "?" . $url["query"] : "");
		if (!isset($url["host"]) && isset($url["path"])) {
			if (!strstr($url["path"],'/')) {
				$url["host"] = $url["path"];
				unset($url["path"]);
			} else {
				$url = @parse_url("http://" . $url["path"] . $url["query"]);
				$url["query"] = (!empty($url["query"]) ? "?" . $url["query"] : "");
			}
		}
		if (!isset($url["port"])) $url["port"] = "80";
		if (!isset($url["path"])) $url["path"] = "/";
		if (!isset($url["scheme"])) $url["scheme"] = "http";
		$HTTP_Request = "HEAD " . $url["path"] . $url["query"] . " HTTP/1.1\r\n"
									. "HOST: " . $url["host"] . "\r\n"
									. "Accept: */*" . "\r\n"
									. "\r\n";
		$fsoc = fsockopen($url["host"], $url["port"], &$errno, &$errstr, 30);
		if (!$fsoc) {
			echo __FUNCTION__ . " <b>Error</b> : $errno - $errstr<br>\n";
			return false;
		}
		fputs($fsoc, $HTTP_Request);
		while (!feof($fsoc)){
			$frec = fgets($fsoc, 256);
			if($frec == "\r\n") break;
			if(preg_match('@^Last-Modified: (.*)@i', $frec, $match)) {
				return strtotime($match[1]);
			}
		}
		return false;
	}
}
?>